﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	
	Public VisibleIndex As Int
End Sub

Sub Globals
	
	Private CustomListView1 As CustomListView
	Private PCLV As PreoptimizedCLV					'PreoptimizedCLV library
	Private xui As XUI
	Type MyImageData (IndexOfFirstImage As Int)
	Private MediaManager As SimpleMediaManager		'SimpleMediaManager library
	Private columsNumber As Int
	Private ImagesNumber As Int	
	Private iv As B4XImageView
End Sub

Sub Activity_Create(FirstTime As Boolean)

	Activity.LoadLayout("1")

	ImagesNumber = Main.lstRepresetativeImages.Size
	LogColor("ImagesNumber = " & ImagesNumber, xui.Color_Blue)
	
	MediaManager.Initialize
	MediaManager.DefaultResizeMode = "FILL_NO_DISTORTIONS"
	PCLV.Initialize(Me, "PCLV", CustomListView1)
	
	Dim height As Int

	If 100%y > 100%x Then
		columsNumber = 2
	Else
		columsNumber = 5
	End If
	
	height = 100%x / columsNumber
	
	'To number of images:
'	For i = 1 To 600 Step 4
	For i = 1 To ImagesNumber Step columsNumber		'For this URL and for Dir Assets
		PCLV.AddItem(height, xui.Color_White, CreateMyImageData(i))
	Next
	PCLV.ShowScrollBar = False 'no fast scrolling
	PCLV.ExtraItems = 3
	PCLV.Commit
	
	Log("VisibleIndex on Create = " & VisibleIndex)
	
	Dim GridRow As Int
	
	'To keep the same items on the screen when you rotate the device:
	Sleep(100)	'ScrollView is not immediately ready
	If 100%y > 100%x Then	'If it is vertical
	
		GridRow = (VisibleIndex * 5) / 2		'GridRow = (numberSavedRow * numberColumnsPrevious) / numberColumns
		CustomListView1.ScrollToItem(GridRow)

	Else	'If it is horizontal
		
		Dim IndexOriginal As Int
		IndexOriginal = (VisibleIndex - 1) * 2		'IndexOriginal = (numberSavedRow - 1) * numberColumnsPrevious
		
		Dim numberColumns As Int
		numberColumns = 5 ' Number of columns in the new grid
		GridRow = (IndexOriginal / numberColumns) + 1
		CustomListView1.ScrollToItem(GridRow)
	End If

	Log("VisibleIndex on Activity_Create = " & VisibleIndex)
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub


Sub Activity_KeyPress (KeyCode As Int) As Boolean
	
	If KeyCode = KeyCodes.KEYCODE_BACK Then
		VisibleIndex = 0
		Activity.Finish
		Return True
	Else
		Return False
	End If
End Sub


Sub CustomListView1_VisibleRangeChanged (FirstIndex As Int, LastIndex As Int)
	For Each i As Int In PCLV.VisibleRangeChanged(FirstIndex, LastIndex)
		Dim item As CLVItem = CustomListView1.GetRawListItem(i)
		Dim data As MyImageData = item.Value
		
		' Check if there are more images
'		LogColor(data.IndexOfFirstImage, xui.Color_Magenta)

		If data.IndexOfFirstImage <= ImagesNumber Then
			Dim pnl As B4XView = xui.CreatePanel("")
			item.Panel.AddView(pnl, 0, 0, item.Panel.Width, item.Panel.Height)

			
			'Create the item layout
			If 100%y > 100%x Then
				pnl.LoadLayout("item2")		'Portrait position: 2 items
			Else
				pnl.LoadLayout("item")		'Landscape position: 5 items
			End If
			
			'		For x = 0 To 3
			For x = 0 To columsNumber - 1
				Dim imageIndex As Int = data.IndexOfFirstImage + x
				pnl.GetView(x).Tag = x
'				pnl.GetView(x).GetView(1).Text = imageIndex
'				Log(imageIndex)
				
				
				If imageIndex >= 0 And imageIndex <= ImagesNumber Then
					
					Log(GetType(Main.lstRepresetativeImages.Get(0)))
					
					If Main.lstRepresetativeImages.Get(0) Is String Then
						
						Private path As String = Main.lstRepresetativeImages.Get(imageIndex - 1)
						Log(path)
						Private LastIndexImg As String = path.LastIndexOf("/")
						Private Directory As String = path.SubString2(0, LastIndexImg)
						Private DirectoryName As String = Directory.SubString2(Directory.LastIndexOf("/")+1, Directory.Length)
						Log(DirectoryName)
						Private FileName As String = path.SubString(LastIndexImg+1)
						MediaManager.SetMediaFromFile(pnl.GetView(x).GetView(0), Directory, FileName, "image/*", Null)

	'					MediaManager.SetMedia(pnl.GetView(x).GetView(0), $"https://picsum.photos/id/${imageIndex}/200/300.jpg"$)	'For this URL
	'					MediaManager.SetMediaFromFile(pnl.GetView(x).GetView(0), Directory, lstImages.Get(imageIndex - 1), "image/*", Null)
						'java.lang.IndexOutOfBoundsException: Index: 13, Size: 13		= more panels than images
					
'						pnl.GetView(x).GetView(0) is pnlImage
						pnl.GetView(x).GetView(1).Text = DirectoryName		'Label
					End If
					
					If Main.lstRepresetativeImages.Get(0) Is Bitmap Then
						
'						MediaManager.AddLocalMedia(imageIndex - 1, Main.lstRepresetativeImages.Get(imageIndex - 1), "image/*")
						
						Dim pan As Panel = pnl.GetView(x).GetView(0)

						'Distorts the image:						
'						pan.SetBackgroundImage(Main.lstRepresetativeImages.Get(imageIndex - 1))
						
						'Distorts the image:
'						Dim bd As BitmapDrawable
'						Dim bmp As Bitmap = Main.lstRepresetativeImages.Get(imageIndex - 1)
'						bmp = bmp.Resize(pan.Width, pan.Height, False)
'						bd.Initialize(bmp)
'						bd.Gravity = Gravity.FILL
'						pan.Background = bd

						'Since MediaManager does not have a method to take the bitmaps from a list, it must be done like this:
						pan.LoadLayout("B4XImageView")
						Dim bmp As Bitmap = Main.lstRepresetativeImages.Get(imageIndex - 1)			
						
						iv.Bitmap = bmp
'						iv.ResizeMode = "FILL_NO_DISTORTIONS"		'Already placed in the layout
					End If
					
				Else
'					pnl.GetView(x).GetView(1).Text = ""		'It's necessary now?
					If pnl.GetView(x).GetView(1).Text = "" Then
						pnl.GetView(x).GetView(1).Visible = False
					End If
				End If
			Next
		End If
	Next

	'The purpose of this call is to find panels that are no longer in the views tree and cancel any ongoing request that is no longer relevant.
	'It also happens automatically from time to time but in this case, as many requests are sent frequently, it is better to force it to trim the cache.
	'Note that you need to add HU2_PUBLIC to the build configuration.
	MediaManager.TrimMediaCache
End Sub

Public Sub CreateMyImageData (IndexOfFirstImage As Int) As MyImageData
	Dim t1 As MyImageData
	t1.Initialize
	t1.IndexOfFirstImage = IndexOfFirstImage
	Return t1
End Sub

Private Sub Panel_Click
	Dim pnl As B4XView = Sender
	Dim PanelIndex As Int = pnl.Tag
	Dim ListIndex As Int = CustomListView1.GetItemFromView(pnl)
	Log($"ListIndex: ${ListIndex}, ImageIndex: ${PanelIndex}"$)
'	ToastMessageShow($"ListIndex: ${ListIndex}, ImageIndex: ${PanelIndex}"$, False)
'	ToastMessageShow("Index of item = " & (ListIndex * 4 + PanelIndex), False)			'Element Number = Row * Number of Columns + Index of Element in Row

	If (ListIndex * columsNumber + PanelIndex) >= ImagesNumber Then Return
	ToastMessageShow("Index of item = " & (ListIndex * columsNumber + PanelIndex), False)			'Element Number = Row * Number of Columns + Index of Element in Row
End Sub

Sub CustomListView1_ScrollChanged (Offset As Int)

	VisibleIndex = CustomListView1.FirstVisibleIndex	'To keep the same items on the screen when you rotate the device
	Log("VisibleIndex on ScrollChanged = " & VisibleIndex)
End Sub
